# [Machine Learning with TensorFlow](http://www.tensorflowbook.com/)

[This](https://github.com/BinRoot/TensorFlow-Book) is the official code repository for [Machine Learning with TensorFlow](http://www.tensorflowbook.com/).

:warning: **Warning**: The book will be released in a month or two, so this repo is a **pre-release** of the entire code. I will be heavily updating this repo in the coming weeks. Stay tuned, and follow along! :)

Get started with machine learning using TensorFlow, Google's latest and greatest machine learning library.

# Summary

## [Chapter 2](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch02_basics) - TensorFlow Basics

- **Concept 1**: Defining tensors
- **Concept 2**: Evaluating ops
- **Concept 3**: Interactive session
- **Concept 4**: Session loggings
- **Concept 5**: Variables
- **Concept 6**: Saving variables
- **Concept 7**: Loading variables
- **Concept 8**: TensorBoard

## [Chapter 3](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch03_regression) - Regression

- **Concept 1**: Linear regression
- **Concept 2**: Polynomial regression
- **Concept 3**: Regularization

## [Chapter 4](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch04_classification) - Classification

- **Concept 1**: Linear regression for classification
- **Concept 2**: Logistic regression
- **Concept 3**: 2D Logistic regression
- **Concept 4**: Softmax classification

## [Chapter 5](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch05_clustering) - Clustering

- **Concept 1**: Clustering
- **Concept 2**: Segmentation
- **Concept 3**: Self-organizing map

## [Chapter 6](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch06_hmm) - Hidden markov models

- **Concept 1**: Forward algorithm
- **Concept 2**: Viterbi decode

## [Chapter 7](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch07_autoencoder) - Autoencoders

- **Concept 1**: Autoencoder
- **Concept 2**: Applying an autoencoder to images
- **Concept 3**: Denoising autoencoder

## [Chapter 8](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch08_rl) - Reinforcement learning

- **Concept 1**: Reinforcement learning

## [Chapter 9](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch09_cnn) - Convolutional Neural Networks

- **Concept 1**: Using CIFAR-10 dataset
- **Concept 2**: Convolutions
- **Concept 3**: Convolutional neural network

## [Chapter 10](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch10_rnn) - Recurrent Neural Network

- **Concept 1**: Loading timeseries data
- **Concept 2**: Recurrent neural networks
- **Concept 3**: Applying RNN to real-world data for timeseries prediction

## [Chapter 11](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch11_seq2seq) - Seq2Seq Model

- **Concept 1**: Multi-cell RNN
- **Concept 2**: Embedding lookup
- **Concept 3**: Seq2seq model

## [Chapter 12](https://github.com/BinRoot/TensorFlow-Book/tree/master/ch12_rank) - Ranking

- **Concept 1**: RankNet
- **Concept 2**: Image embedding
- **Concept 3**: Image ranking